StarObjectDraw Class Reference

the main class to read a StarOffice draw More...

`#include <StarObjectDraw.hxx>`

Inheritance diagram for StarObjectDraw:

## Public Member Functions

| StarObjectDraw (StarObject const &orig, bool duplicateState)
| constructor
| ~StarObjectDraw () override
| destructor
bool | parse ()
| try to parse the current object
bool | updatePageSpans (std::vector< STOFFPageSpan > &pageSpan, int &numPages) const
| try to update the page span (to create draw document)
bool | sendPages (STOFFGraphicListenerPtr listener)
| try to send the different page
bool | sendMasterPages (STOFFGraphicListenerPtr listener)
| try to send the master pages
Public Member Functions inherited from StarObject
| StarObject (char const *passwd, std::shared_ptr< STOFFOLEParser > &oleParser, std::shared_ptr< STOFFOLEParser::OleDirectory > &directory)
| constructor
virtual | ~StarObject ()
| destructor
bool | parse ()
| try to parse data
STOFFDocument::Kind | getDocumentKind () const
| returns the document kind
char const * | getPassword () const
| returns the document password (the password given by the user)
std::shared_ptr< STOFFOLEParser::OleDirectory > | getOLEDirectory ()
| returns the object directory
std::shared_ptr< StarAttributeManager > | getAttributeManager ()
| returns the attribute manager
std::shared_ptr< StarFormatManager > | getFormatManager ()
| returns the format manager
librevenge::RVNGPropertyList const & | getMetaData () const
| returns the meta data (filled by readSfxDocumentInformation)
librevenge::RVNGString | getUserNameMetaData (int i) const
| returns the ith user meta data
void | cleanPools ()
| clean each pool
std::shared_ptr< StarItemPool > | getNewItemPool (StarItemPool::Type type)
| returns a new item pool for this document
std::shared_ptr< StarItemPool > | findItemPool (StarItemPool::Type type, bool isInside)
| check if a pool corresponding to a given type is opened if so returned it.
std::shared_ptr< StarItemPool > | getCurrentPool (bool onlyInside=true)
| returns the current all/inside pool
bool | readPersistData (StarZone &zone, long endPos)
| try to read persist data
bool | readSfxStyleSheets (STOFFInputStreamPtr input, std::string const &name)
| try to read a spreadshet style zone: SfxStyleSheets
bool | readItemSet (StarZone &zone, std::vector< STOFFVec2i > const &limits, long endPos, StarItemSet &itemSet, StarItemPool *pool=nullptr, bool isDirect=false)
| try to read a list of item

## Protected Member Functions

bool | readDrawDocument (STOFFInputStreamPtr input, std::string const &fileName)
| try to read a spreadsheet zone: StarDrawDocument .sdd
bool | readSfxStyleSheets (STOFFInputStreamPtr input, std::string const &fileName)
| try to read a draw style zone: SfxStyleSheets
Protected Member Functions inherited from StarObject
bool | readPersistElements (STOFFInputStreamPtr input, std::string const &name)
| the "persist elements" small ole: the list of object
bool | readSfxDocumentInformation (STOFFInputStreamPtr input, std::string const &name)
| try to read the document information : "SfxDocumentInformation"
bool | readSfxPreview (STOFFInputStreamPtr input, std::string const &name)
| try to read the preview : "SfxPreview"
bool | readSfxWindows (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the windows information : "SfxWindows"
bool | readStarFrameworkConfigFile (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the "Star Framework Config File"
bool | readStarFrameworkConfigItem (STOFFEntry &entry, STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read an item in a "Star Framework Config File"
| StarObject (StarObject const &orig, bool duplicateState)
| copy constructor

## Static Protected Member Functions

static bool | readSdrCustomShow (StarZone &zone)
| try to read a SdCustomShow
static bool | readSdrFrameView (StarZone &zone)
| try to read a SdrFrameView
static bool | readSdrView (StarZone &zone)
| try to read a SdrView
static bool | readSdrHelpLine (StarZone &zone)
| try to read a SdrHelpLine
static bool | readSdrHelpLineSet (StarZone &zone)
| try to read a SdrHelpLine list
static bool | readPresentationData (StarZone &zone)
| try to read the presentation data

## Protected Attributes

std::shared_ptr< StarObjectDrawInternal::State > | m_drawState
| the state
Protected Attributes inherited from StarObject
char const * | m_password
| the document password
std::shared_ptr< STOFFOLEParser > | m_oleParser
| the ole parser
std::shared_ptr< STOFFOLEParser::OleDirectory > | m_directory
| the directory
std::shared_ptr< StarObjectInternal::State > | m_state
| the state
librevenge::RVNGPropertyList | m_metaData
| the meta data

## Detailed Description

the main class to read a StarOffice draw

Note
  currently, it contains only static function :-~

## Constructor & Destructor Documentation

## StarObjectDraw()

StarObjectDraw::StarObjectDraw | ( | StarObject const & | orig,
|  | bool | duplicateState )

constructor

## ~StarObjectDraw()

StarObjectDraw::~StarObjectDraw | ( |  | ) |

override

destructor

## Member Function Documentation

## parse()

bool StarObjectDraw::parse | ( |  | ) |

try to parse the current object

Referenced by StarFileManager::checkUnparsed(), SDXParser::createZones(), and StarFileManager::readOLEDirectory().

## readDrawDocument()

bool StarObjectDraw::readDrawDocument | ( | STOFFInputStreamPtr | input,
|  | std::string const & | fileName )

protected

try to read a spreadsheet zone: StarDrawDocument .sdd

Referenced by parse().

## readPresentationData()

bool StarObjectDraw::readPresentationData | ( | StarZone & | zone | ) |

static protected

try to read the presentation data

Referenced by readDrawDocument().

## readSdrCustomShow()

bool StarObjectDraw::readSdrCustomShow | ( | StarZone & | zone | ) |

static protected

try to read a SdCustomShow

Referenced by readPresentationData().

## readSdrFrameView()

bool StarObjectDraw::readSdrFrameView | ( | StarZone & | zone | ) |

static protected

try to read a SdrFrameView

Referenced by readPresentationData().

## readSdrHelpLine()

bool StarObjectDraw::readSdrHelpLine | ( | StarZone & | zone | ) |

static protected

try to read a SdrHelpLine

Referenced by readSdrHelpLineSet().

## readSdrHelpLineSet()

bool StarObjectDraw::readSdrHelpLineSet | ( | StarZone & | zone | ) |

static protected

try to read a SdrHelpLine list

Referenced by readSdrFrameView().

## readSdrView()

bool StarObjectDraw::readSdrView | ( | StarZone & | zone | ) |

static protected

try to read a SdrView

Referenced by readSdrFrameView().

## readSfxStyleSheets()

bool StarObjectDraw::readSfxStyleSheets | ( | STOFFInputStreamPtr | input,
|  | std::string const & | fileName )

protected

try to read a draw style zone: SfxStyleSheets

Referenced by parse().

## sendMasterPages()

bool StarObjectDraw::sendMasterPages | ( | STOFFGraphicListenerPtr | listener | ) |

try to send the master pages

## sendPages()

bool StarObjectDraw::sendPages | ( | STOFFGraphicListenerPtr | listener | ) |

try to send the different page

Referenced by StarFileManager::readOLEDirectory().

## updatePageSpans()

bool StarObjectDraw::updatePageSpans | ( | std::vector< STOFFPageSpan > & | pageSpan,
|  | int & | numPages ) const

try to update the page span (to create draw document)

Referenced by StarFileManager::readOLEDirectory().

## Member Data Documentation

## m_drawState

std::shared_ptr<StarObjectDrawInternal::State> StarObjectDraw::m_drawState

protected

the state

Referenced by readDrawDocument(), sendMasterPages(), sendPages(), StarObjectDraw(), and updatePageSpans().

The documentation for this class was generated from the following files:

- StarObjectDraw.hxx
- StarObjectDraw.cxx